/******************************************************************************
*       SOFA, Simulation Open-Framework Architecture, development version     *
*                (c) 2006-2016 INRIA, USTL, UJF, CNRS, MGH                    *
*                                                                             *
* This library is free software; you can redistribute it and/or modify it     *
* under the terms of the GNU Lesser General Public License as published by    *
* the Free Software Foundation; either version 2.1 of the License, or (at     *
* your option) any later version.                                             *
*                                                                             *
* This library is distributed in the hope that it will be useful, but WITHOUT *
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       *
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License *
* for more details.                                                           *
*                                                                             *
* You should have received a copy of the GNU Lesser General Public License    *
* along with this library; if not, write to the Free Software Foundation,     *
* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA.          *
*******************************************************************************
*                               SOFA :: Modules                               *
* Authors: Igor Peterlik                                                      *
*                                                                             *
* Contact information: contact@sofa-framework.org                             *
******************************************************************************/


#define SOFA_COMPONENT_BEZIER_SEGMENT_TREE_CPP

#include "BezierSegmentTree.inl"
#include <sofa/defaulttype/RigidTypes.h>
#include <sofa/defaulttype/VecTypes.h>
#include <sofa/core/ObjectFactory.h>


namespace sofa
{

namespace component
{

namespace misc
{

using namespace sofa::defaulttype;
SOFA_DECL_CLASS(BezierSegmentTree)


// Register in the Factory
int BezierSegmentTreeClass = core::RegisterObject("Provides an interpolation based on Bezier Cubic functions")

#ifndef SOFA_FLOAT
.add< BezierSegmentTree<Rigid3dTypes> >(true)
#endif
#ifndef SOFA_DOUBLE
.add< BezierSegmentTree<Rigid3fTypes> >()
#endif
;

#ifndef SOFA_FLOAT
template class SOFA_BEZIER_SKELETONIZATION_API BezierSegmentTree<Rigid3dTypes>;
#endif
#ifndef SOFA_DOUBLE
template class SOFA_BEZIER_SKELETONIZATION_API  BezierSegmentTree<Rigid3fTypes>;
#endif



} // namespace misc

} // namespace component

} // namespace sofa
